/*
** a_health.cpp
** All health items
**
**---------------------------------------------------------------------------
** Copyright 2000-2016 Randy Heit
** Copyright 2006-2016 Cheistoph Oelckers
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
**
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
** 3. The name of the author may not be used to endorse or promote products
**    derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
** IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
** IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
** INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
** NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
** THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**---------------------------------------------------------------------------
**
*/

#include "d_player.h"
#include "a_morph.h"
#include "a_health.h"
#include "serializer.h"
#include "p_local.h"

//===========================================================================
//
// Classes
//
//===========================================================================

IMPLEMENT_CLASS(PClassHealth, false, false)
IMPLEMENT_CLASS(AHealth, false, false)
DEFINE_FIELD(AHealth, PrevHealth)
DEFINE_FIELD(PClassHealth, LowHealth)
DEFINE_FIELD(PClassHealth, LowHealthMessage)

//===========================================================================
//
// PClassHealth Constructor
//
//===========================================================================

PClassHealth::PClassHealth()
{
	LowHealth = 0;
}

//===========================================================================
//
// PClassHealth :: DeriveData
//
//===========================================================================

void PClassHealth::DeriveData(PClass *newclass)
{
	assert(newclass->IsKindOf(RUNTIME_CLASS(PClassHealth)));
	Super::DeriveData(newclass);
	PClassHealth *newc = static_cast<PClassHealth *>(newclass);
	
	newc->LowHealth = LowHealth;
	newc->LowHealthMessage = LowHealthMessage;
}


IMPLEMENT_CLASS(AHealthPickup, false, false)

DEFINE_FIELD(AHealthPickup, autousemode)

//===========================================================================
//
// AHealthPickup :: Serialize
//
//===========================================================================

void AHealthPickup::Serialize(FSerializer &arc)
{
	Super::Serialize(arc);
	auto def = (AHealthPickup*)GetDefault();
	arc("autousemode", autousemode, def->autousemode);
}

